// Copyright (c) 2005 Masakazu Emi All Rights Reserved.
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Emi.Win.SrcToHtml
{
	public class HtmlCharactorConverter
	{
		private Dictionary<char, string> _convertions;
		private bool _isConvertWhiteSpace;
		private bool _isUseBR;

		private TextWriter _writer;
		public TextWriter Writer
		{
			get { return _writer; }
		}

		/// <summary>
		/// 󔒂u邩擾܂B
		/// </summary>
		public bool IsConvertWhiteSpace
		{
			get { return _isConvertWhiteSpace; }
		}

		/// <summary>
		/// s<BR/>ɒu邩擾܂B
		/// </summary>
		public bool IsUseBR
		{
			get { return _isUseBR; }
		}

		public HtmlCharactorConverter(TextWriter writer, bool isConvertWhiteSpace, bool isUseBR)
		{
			_writer = writer;
			_isConvertWhiteSpace = isConvertWhiteSpace;
			_isUseBR = isUseBR;
			Dictionary<char, string> conv = new Dictionary<char, string>();
			conv.Add('>', "&gt;");
			conv.Add('<', "&lt;");
			if(IsConvertWhiteSpace)
				conv.Add(' ', "&nbsp;");
			if(IsUseBR)
				conv.Add('\n', "<BR/>\n");
			_convertions = conv;
		}

		public virtual bool Convert(char c)
		{
			string result = null;
			bool canConvertion = _convertions.ContainsKey(c);
			if (canConvertion)
				result = _convertions[c];
			else
				result = c.ToString();
			Writer.Write(result);
			return canConvertion;
		}

		public virtual void Convert(string s)
		{
			foreach (char c in s)
				Convert(c);
		}
	}
}
