// Copyright (c) 2005-2006 Masakazu Emi All Rights Reserved.
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Reflection;
using System.Web;
using System.Web.UI;
using System.Xml;
using System.Xml.Serialization;

using Emi.Library.SrcAnalyzerCore.Generator;
using Emi.Library.SrcAnalyzerCore.Model;

namespace Emi.Win.SrcToHtml
{
	public class SrcXmlToHtml
	{
		public const string TAG = "span";
		public const int TAB_SIZE = 4;

		private string _src;
		private string _type;
		private string _keywordDirectory;
		private int _tabSize;
		private bool _isConvertWhiteSpace;
		private bool _isUseBR;

		/// <summary>
		/// ^uTCYBftHg4
		/// </summary>
		public int TabSize
		{
			get { return _tabSize; }
			set { _tabSize = value; }
		}

		/// <summary>
		/// 󔒂u邩擾/ݒ肵܂B
		/// </summary>
		public bool IsConvertWhiteSpace
		{
			get { return _isConvertWhiteSpace; }
			set { _isConvertWhiteSpace = value; }
		}

		/// <summary>
		/// s&ltBR/&gtɒu邩擾/ݒ肵܂B
		/// </summary>
		public bool IsUseBR
		{
			get { return _isUseBR; }
			set { _isUseBR = value; }
		}

		public SrcXmlToHtml(string src, string type, string keywordDirectory)
		{
			_src = src;
			_type = type;
			_keywordDirectory = keywordDirectory;
			_tabSize = TAB_SIZE;
		}

		/// <summary>
		/// HTMLo
		/// </summary>
		/// <param name="writer"></param>
		public void WriteHtml(TextWriter writer)
		{
			//͍ς݂̃\[X擾
			//\[XR[h͂XML𐶐B
			SrcToXmlGenerator g
				= GeneratorFactory.CreateGenerator(
					_type, new TabParser(TabSize, _src).Parse(), _keywordDirectory);
			g.Parse();
			Source s = g.Result;

			//PHtmlTextWriterœfoB
			using (HtmlTextWriter htmlWriter = new HtmlTextWriter(writer))
			{
				HtmlCharactorConverter converter = new HtmlCharactorConverter(htmlWriter, IsConvertWhiteSpace, IsUseBR);
				foreach (Block block in s.BlockArray)
				{
					if (block.Type != null && block.Type.Length > 0)
					{
						htmlWriter.WriteBeginTag(TAG);
						htmlWriter.WriteAttribute("class", block.Type);
						htmlWriter.Write(HtmlTextWriter.TagRightChar);
					}

					//HTMLpɕϊ
					converter.Convert(block.Source);

					if (block.Type != null && block.Type.Length > 0)
						htmlWriter.WriteEndTag(TAG);
				}
			}
		}


		/// <summary>
		/// ϊ\ȃ\[Xʂ̖O񋓂Ce[^擾܂B
		/// </summary>
		public static IEnumerable<string> SourceTypes
		{
			get { return GetTypeIterator(typeof(GeneratorFactory.Type), typeof(GeneratorFactory.Type)); }
		}
		/// <summary>
		/// ^̃o̓Aw肳ꂽɓo̖O񋓂Ce[^擾܂B
		/// </summary>
		/// <returns></returns>
		private static IEnumerable<string> GetTypeIterator(Type t, Type accept)
		{
			foreach (FieldInfo info in t.GetFields())
				if (info.FieldType == accept)
					yield return info.Name;
		}

	}
}
