// Copyright (c) 2005 Masakazu Emi All Rights Reserved.
using System;
using System.Collections.Generic;
using System.Text;

namespace Emi.Win.SrcToHtml
{
	public class TabParser
	{
		private int _tabSize;
		private string _src;

		public TabParser(int tabSize, string src)
		{
			_tabSize = tabSize;
			_src = src;
		}

		public string Parse()
		{
			int column = 0;
			int line = 1;

			string s = _src.Replace("\r\n", "\n");
			StringBuilder sb = new StringBuilder();
			foreach(char c in s)
			{
				if (c == '\t')
				{
					column = 0;
					sb.Append(' ', _tabSize - column % _tabSize);
				}
				else if (c == '\n')
				{
					column = 0;
					line++;
					sb.Append(c);
				}
				else
				{
					column++;
					sb.Append(c);
				}
			}
			return sb.ToString();
		}

		protected bool IsWideChar(char c)
		{
			return Encoding.Default.GetByteCount(new char[] { c }) == 2;
		}
	}
}
